Index: boot/Makefile
===================================================================
--- boot/Makefile	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/Makefile	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -40,8 +40,5 @@
 	$(PACK) $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) arch/$(KARCH) $(COMPONENTS)
 
-$(INITRD).img: $(INITRD).fs
-	$(MKHORD) $(PAGE_SIZE) $< $@
-
-$(INITRD).fs: build_dist
+$(INITRD).img: build_dist
 ifeq ($(RDFMT),tmpfs)
 	$(MKTMPFS) $(DIST_PATH) $@
@@ -95,5 +92,5 @@
 
 clean_dist:
-	rm -f $(INITRD).fs $(INITRD).img $(COMPS_H) $(COMPS_C) $(LINK) $(LINK).comp *.co
+	rm -f $(INITRD).img $(COMPS_H) $(COMPS_C) $(LINK) $(LINK).comp *.co
 	rm -f $(USPACE_PATH)/dist/srv/*
 	rm -rf $(USPACE_PATH)/dist/drv/*
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/Makefile.common	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -53,5 +53,4 @@
 SANDBOX = pack
 PACK = $(TOOLS_PATH)/pack.py
-MKHORD = $(TOOLS_PATH)/mkhord.py
 MKTMPFS = $(TOOLS_PATH)/mktmpfs.py
 MKFAT = $(TOOLS_PATH)/mkfat.py
@@ -107,6 +106,4 @@
 	$(USPACE_PATH)/srv/fs/ext2fs/ext2fs \
 	$(USPACE_PATH)/srv/taskmon/taskmon \
-	$(USPACE_PATH)/srv/hw/netif/ne2000/ne2000 \
-	$(USPACE_PATH)/srv/net/netif/lo/lo \
 	$(USPACE_PATH)/srv/net/nil/eth/eth \
 	$(USPACE_PATH)/srv/net/nil/nildummy/nildummy \
@@ -124,5 +121,7 @@
 	test/test1 \
 	test/test2 \
-	test/test3
+	test/test3 \
+	nic/lo \
+	nic/ne2k
 
 RD_DRV_CFG =
@@ -203,6 +202,6 @@
 NET_CFG = \
 	$(USPACE_PATH)/srv/net/cfg/general \
-	$(USPACE_PATH)/srv/net/cfg/lo \
-	$(USPACE_PATH)/srv/net/cfg/ne2k
+	$(USPACE_PATH)/srv/net/cfg/lo.nic \
+	$(USPACE_PATH)/srv/net/cfg/ne2k.nic
 endif
 
Index: boot/Makefile.grub
===================================================================
--- boot/Makefile.grub	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/Makefile.grub	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -31,31 +31,66 @@
 include Makefile.common
 
-STAGE2 = grub/stage2_eltorito
-STAGE2_IN = boot/$(STAGE2)
+GRUB = grub.$(GRUB_ARCH)
+BOOT = $(DISTROOT)/boot
+
+ELTORITO = boot/grub/$(GRUB_ARCH).img
+IMAGE = $(DISTROOT)/$(ELTORITO)
+
+ifeq ($(GRUB_ARCH),pc)
+	BOOT_CONFIG = $(BOOT)/grub/i386-pc/grub.cfg
+	MULTIBOOT_CMD = multiboot
+	MODULE_CMD = module
+endif
+ifeq ($(GRUB_ARCH),efi)
+	BOOT_CONFIG = $(BOOT)/grub/grub.cfg
+	MULTIBOOT_CMD = multiboot2
+	MODULE_CMD = module2
+endif
 
 all: $(BOOT_OUTPUT)
 
 $(BOOT_OUTPUT): build_dist
-	mkisofs -J -r -b $(STAGE2_IN) -no-emul-boot -boot-load-size 4 -boot-info-table -o $@ $(DISTROOT)/
+ifeq ($(GRUB_ARCH),pc)
+	mkisofs -J -r -input-charset utf-8 -V "HelenOS boot ISO" -eltorito-boot $(ELTORITO) -no-emul-boot -boot-load-size 64 -boot-info-table -o $@ $(DISTROOT)/
+endif
+ifeq ($(GRUB_ARCH),efi)
+	mkisofs -J -r -input-charset utf-8 -V "HelenOS boot ISO" -efi-boot $(ELTORITO) -o $@ $(DISTROOT)/
+endif
 
 build_dist: clean
-	mkdir -p $(DISTROOT)/boot/grub
-	cp $(STAGE2) $(DISTROOT)/boot/grub/
+	mkdir -p $(BOOT)
+	cp -r $(GRUB) $(BOOT)/grub
+ifeq ($(GRUB_ARCH),efi)
+	gunzip $(IMAGE)
+endif
+	
 	for module in $(COMPONENTS) ; do \
-		cp "$$module" $(DISTROOT)/boot/ ; \
+		cp "$$module" $(BOOT)/ ; \
 	done
 	
-	echo "default 0" > $(DISTROOT)/boot/grub/menu.lst
-	echo "timeout 10" >> $(DISTROOT)/boot/grub/menu.lst
-	echo "" >> $(DISTROOT)/boot/grub/menu.lst
-	echo "title=HelenOS" >> $(DISTROOT)/boot/grub/menu.lst
-	echo "	root (cd)" >> $(DISTROOT)/boot/grub/menu.lst
+	echo "set default=0" > $(BOOT_CONFIG)
+	echo "set timeout=10" >> $(BOOT_CONFIG)
+	echo "" >> $(BOOT_CONFIG)
+	
+ifeq ($(GRUB_ARCH),pc)
+	echo "insmod vbe" >> $(BOOT_CONFIG)
+	echo "insmod vga" >> $(BOOT_CONFIG)
+endif
+ifeq ($(GRUB_ARCH),efi)
+	echo "insmod efi_gop" >> $(BOOT_CONFIG)
+	echo "insmod efi_uga" >> $(BOOT_CONFIG)
+endif
+	echo "" >> $(BOOT_CONFIG)
+	
+	echo "menuentry 'HelenOS $(RELEASE)' --class helenos --class os {" >> $(BOOT_CONFIG)
 	for module in $(MODULES) ; do \
+		echo "	echo 'Loading $$module'" >> $(BOOT_CONFIG) ; \
 		if [ "$$module" = "kernel.bin" ] ; then \
-			echo "	kernel /boot/$$module" >> $(DISTROOT)/boot/grub/menu.lst ; \
+			echo "	$(MULTIBOOT_CMD) /boot/$$module" >> $(BOOT_CONFIG) ; \
 		else \
-			echo "	module /boot/$$module" >> $(DISTROOT)/boot/grub/menu.lst ; \
+			echo "	$(MODULE_CMD) /boot/$$module /boot/$$module" >> $(BOOT_CONFIG) ; \
 		fi \
 	done
+	echo "}" >> $(BOOT_CONFIG)
 
 clean:
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/amd64/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -27,6 +27,4 @@
 #
 
-PAGE_SIZE = 4096
-
 RD_SRVS_ESSENTIAL += \
 	$(USPACE_PATH)/srv/hw/char/i8042/i8042 \
@@ -51,5 +49,4 @@
 	bus/usb/usbmast \
 	bus/usb/usbmid \
-	bus/usb/usbmouse \
 	bus/usb/vhc
 
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/arm32/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -39,5 +39,4 @@
 BITS = 32
 ENDIANESS = LE
-PAGE_SIZE = 4096
 
 RD_SRVS_ESSENTIAL += \
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/ia64/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -33,5 +33,4 @@
 BITS = 64
 ENDIANESS = LE
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -fno-unwind-tables -mfixed-range=f32-f127 -mno-pic -mno-sdata
 
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/mips32/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -29,5 +29,4 @@
 BFD_ARCH = mips
 BITS = 32
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mips3 -mabi=32
 
Index: boot/arch/mips64/Makefile.inc
===================================================================
--- boot/arch/mips64/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/mips64/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -29,5 +29,4 @@
 BFD_ARCH = mips:4000
 BITS = 64
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mips3 -mabi=64
 
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/ppc32/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -37,5 +37,4 @@
 BITS = 32
 ENDIANESS = BE
-PAGE_SIZE = 4096
 EXTRA_CFLAGS = -mcpu=powerpc -msoft-float -m32
 
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ boot/arch/sparc64/Makefile.inc	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -37,5 +37,4 @@
 BITS = 64
 ENDIANESS = BE
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -mcpu=ultrasparc -m64 -mno-fpu -mcmodel=medlow
 
